// Code generated by mockery v2.53.0. DO NOT EDIT.

package db

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	models "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/models"
)

// MockMemberships is an autogenerated mock type for the Memberships type
type MockMemberships struct {
	mock.Mock
}

// CreateMembership provides a mock function with given fields: ctx, input
func (_m *MockMemberships) CreateMembership(ctx context.Context, input *models.Membership) (*models.Membership, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for CreateMembership")
	}

	var r0 *models.Membership
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.Membership) (*models.Membership, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.Membership) *models.Membership); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Membership)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.Membership) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteMembership provides a mock function with given fields: ctx, membership
func (_m *MockMemberships) DeleteMembership(ctx context.Context, membership *models.Membership) error {
	ret := _m.Called(ctx, membership)

	if len(ret) == 0 {
		panic("no return value specified for DeleteMembership")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.Membership) error); ok {
		r0 = rf(ctx, membership)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetMembershipByID provides a mock function with given fields: ctx, id
func (_m *MockMemberships) GetMembershipByID(ctx context.Context, id string) (*models.Membership, error) {
	ret := _m.Called(ctx, id)

	if len(ret) == 0 {
		panic("no return value specified for GetMembershipByID")
	}

	var r0 *models.Membership
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.Membership, error)); ok {
		return rf(ctx, id)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.Membership); ok {
		r0 = rf(ctx, id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Membership)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetMembershipByPRN provides a mock function with given fields: ctx, prn
func (_m *MockMemberships) GetMembershipByPRN(ctx context.Context, prn string) (*models.Membership, error) {
	ret := _m.Called(ctx, prn)

	if len(ret) == 0 {
		panic("no return value specified for GetMembershipByPRN")
	}

	var r0 *models.Membership
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.Membership, error)); ok {
		return rf(ctx, prn)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.Membership); ok {
		r0 = rf(ctx, prn)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Membership)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, prn)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetMemberships provides a mock function with given fields: ctx, input
func (_m *MockMemberships) GetMemberships(ctx context.Context, input *GetMembershipsInput) (*MembershipsResult, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for GetMemberships")
	}

	var r0 *MembershipsResult
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *GetMembershipsInput) (*MembershipsResult, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *GetMembershipsInput) *MembershipsResult); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*MembershipsResult)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *GetMembershipsInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateMembership provides a mock function with given fields: ctx, membership
func (_m *MockMemberships) UpdateMembership(ctx context.Context, membership *models.Membership) (*models.Membership, error) {
	ret := _m.Called(ctx, membership)

	if len(ret) == 0 {
		panic("no return value specified for UpdateMembership")
	}

	var r0 *models.Membership
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.Membership) (*models.Membership, error)); ok {
		return rf(ctx, membership)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.Membership) *models.Membership); ok {
		r0 = rf(ctx, membership)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Membership)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.Membership) error); ok {
		r1 = rf(ctx, membership)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// NewMockMemberships creates a new instance of MockMemberships. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockMemberships(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockMemberships {
	mock := &MockMemberships{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
